import cn.hutool.db.Db;
import cn.hutool.db.Entity;
import cn.hutool.db.ds.simple.SimpleDataSource;
import lombok.SneakyThrows;

import javax.sql.DataSource;
import java.sql.SQLException;
import java.util.List;

public class SqlTest {

    static String url = "jdbc:mysql://127.0.0.1:3306/fly4.0?useUnicode=true&characterEncoding=utf8&zeroDateTimeBehavior=convertToNull&useSSL=true&serverTimezone=GMT%2B8&nullCatalogMeansCurrent=true";
    static String user = "root";
    static String pass = "root";

    static DataSource dataSource = new SimpleDataSource(url, user, pass);
    static Db db = new Db(dataSource);

    @SneakyThrows
    public static void main(String[] args) {
        // 查询所有数据库
        List<Entity> showDatabases = db.query("SHOW DATABASES");
        // 循环数据库
        for (Entity showDatabase : showDatabases) {
            // 并找出以bytesailing_开头的数据库
            String database = showDatabase.getStr("database");
            if (database.startsWith("bytesailing_")) {
                // 删除指定数据库中所有表中的tenant_id不等于wdly的数据
                deleteTenantId(database);
            }
        }
    }

    /**
     * 查询指定库中所有表，并找出包含tenant_id字段的表，删除表中tenant_id不等于wdly的数据
     */
    private static void deleteTenantId(String database) throws SQLException {
        // 查询指定库中所有表
        List<Entity> tables = db.query("SHOW TABLES FROM " + database);
        for (Entity table : tables) {
            // 获取表名
            String tableName = table.getStr("tables_in_" + database);
            // 查询表中是否包含tenant_id字段
            List<Entity> columns = db.query("SELECT column_name " +
                    "FROM information_schema.columns " +
                    "WHERE table_schema = '" + database + "' " +
                    "AND table_name = '" + tableName + "' " +
                    "AND column_name = 'tenant_id' ");
            // 删除表中tenant_id不等于wdly的数据
            if (!columns.isEmpty()) {
                String sql = "DELETE FROM " + database + "." + tableName + " WHERE tenant_id != 'wdly'";
                db.execute(sql);
            }
        }
    }

}