package com.fjhx.sale.service.documents.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.sale.entity.documents.dto.DocumentsProductSelectDto;
import com.fjhx.sale.entity.documents.po.DocumentsProduct;
import com.fjhx.sale.entity.documents.vo.DocumentsProductVo;
import com.fjhx.sale.mapper.documents.DocumentsProductMapper;
import com.fjhx.sale.service.documents.DocumentsProductService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 单证-产品表 服务实现类
 * </p>
 *
 * @author
 * @since 2023-04-20
 */
@Service
public class DocumentsProductServiceImpl extends ServiceImpl<DocumentsProductMapper, DocumentsProduct> implements DocumentsProductService {

    @Override
    public Page<DocumentsProductVo> getPage(DocumentsProductSelectDto dto) {
        IWrapper<DocumentsProduct> wrapper = getWrapper();
        wrapper.orderByDesc("dp", DocumentsProduct::getId);
        Page<DocumentsProductVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

}
