package com.fjhx.victoriatourist.controller.jd;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundDto;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundSelectDto;
import com.fjhx.victoriatourist.entity.jd.vo.JdRefundVo;
import com.fjhx.victoriatourist.service.jd.JdRefundService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;


/**
 * <p>
 * 京东售后退货 前端控制器
 * </p>
 *
 * @author
 * @since 2024-09-25
 */
@RestController
@RequestMapping("/jdRefund")
public class JdRefundController {

    @Autowired
    private JdRefundService JdRefundService;

    /**
     * 京东售后退货列表
     */
    @GetMapping("/getPage")
    public Page<JdRefundVo> getPage(JdRefundSelectDto dto) {
        return JdRefundService.getPage(dto);
    }

    /**
     * 售后退货确认
     */
    @PostMapping("confirm")
    public void confirm(@RequestBody JdRefundDto dto) {
        JdRefundService.confirm(dto.getId());
    }

    /**
     * 售后退货取消确认
     */
    @PostMapping("cancelConfirm")
    public void cancelConfirm(@RequestBody JdRefundDto dto) {
        JdRefundService.cancelConfirm(dto.getId());
    }

    /**
     * 售后退货确认Excel导入
     */
    @PostMapping("/confirmExcelImport")
    public void confirmExcelImport(@RequestParam("file") MultipartFile file) {
        JdRefundService.confirmExcelImport(file);
    }

}
