package com.fjhx.victoriatourist.controller.jd;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundNotQualityCheckSelectDto;
import com.fjhx.victoriatourist.entity.jd.po.JdRefundQualityCheck;
import com.fjhx.victoriatourist.entity.jd.vo.JdRefundNotQualityCheckVo;
import com.fjhx.victoriatourist.service.jd.JdRefundNotQualityCheckService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;


/**
 * <p>
 * 京东售后退货待质检 前端控制器
 * </p>
 *
 * @author
 * @since 2024-09-28
 */
@RestController
@RequestMapping("/jdRefundNotQualityCheck")
public class JdRefundNotQualityCheckController {

    @Autowired
    private JdRefundNotQualityCheckService jdRefundNotQualityCheckService;

    /**
     * 京东售后退货待质检分页
     */
    @PostMapping("/page")
    public Page<JdRefundNotQualityCheckVo> page(@RequestBody JdRefundNotQualityCheckSelectDto dto) {
        return jdRefundNotQualityCheckService.getPage(dto);
    }

    /**
     * 提交质检
     */
    @PostMapping("/submitQualityCheck")
    public void submitQualityCheck(@RequestBody List<JdRefundQualityCheck> dto) {
        jdRefundNotQualityCheckService.submitQualityCheck(dto);
    }

    /**
     * 京东售后退货待质检导入列表
     */
    @PostMapping("/excelList")
    public List<JdRefundNotQualityCheckVo> excelList(@RequestParam("file") MultipartFile file) {
        return jdRefundNotQualityCheckService.excelList(file);
    }


}
