package com.fjhx.victoriatourist.controller.jd;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundQualityCheckDto;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundQualityCheckSelectDto;
import com.fjhx.victoriatourist.entity.jd.vo.JdRefundQualityCheckVo;
import com.fjhx.victoriatourist.service.jd.JdRefundQualityCheckService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 京东售后退货质检 前端控制器
 * </p>
 *
 * @author
 * @since 2024-09-27
 */
@RestController
@RequestMapping("/jdRefundQualityCheck")
public class JdRefundQualityCheckController {

    @Autowired
    private JdRefundQualityCheckService jdRefundQualityCheckService;

    /**
     * 京东售后退货质检分页
     */
    @GetMapping("/getPage")
    public Page<JdRefundQualityCheckVo> page(JdRefundQualityCheckSelectDto dto) {
        return jdRefundQualityCheckService.getPage(dto);
    }

    /**
     * 处理
     */
    @PostMapping("/handle")
    public void handle(@RequestBody JdRefundQualityCheckDto dto) {
        jdRefundQualityCheckService.handle(dto);
    }

    /**
     * 处理
     */
    @PostMapping("/verify")
    public void verify(@RequestBody JdRefundQualityCheckDto dto) {
        jdRefundQualityCheckService.verify(dto);
    }



}
