package com.fjhx.victoriatourist.entity.jd.po;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 京东订单明细
 * </p>
 *
 * @author
 * @since 2023-04-20
 */
@Getter
@Setter
@TableName("jd_order_details")
public class JdOrderDetails extends BasePo {

    /**
     * 京东订单id
     */
    private Long jdOrderId;

    /**
     * 产品id
     */
    @NotNull(message = "产品id不能为空")
    private Long productId;

    /**
     * 单价
     */
    @NotNull(message = "单价不能为空")
    private BigDecimal price;

    /**
     * 数量
     */
    @NotNull(message = "数量不能为空")
    private BigDecimal quantity;

    /**
     * 小计
     */
    private BigDecimal subtotal;

    /**
     * 备注
     */
    private String remark;

    /**
     * 出库数量
     */
    private BigDecimal quantityDelivered;


    //----------------------京东订单明细字段开始--------------------------------------
    private Long orderId;
    private Long wareId;
    private Integer deliverCenterId;
    private String deliverCenterName;
    private String wareName;
    private BigDecimal purchasePrice;
    private Integer originalNum;
    private Integer confirmNum;
    private Integer actualNum;
    private String nonDeliveryReason;
    private Integer backExplanationType;
    private BigDecimal totoalPrice;
    private String isbn;
    private BigDecimal makePrice;
    private BigDecimal currentMakePrice;
    private BigDecimal discount;
    private Integer storeId;
    private String storeName;
    private String wareProperty;//目前是json考虑新表
    //----------------------京东订单明细字段结束--------------------------------------
    /**
     * 是否有异常
     **/
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String hasEx;
    /**
     * 异常描述
     **/
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String exDesc;
    /**
     * 处理状态
     **/
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String handleStatus;
    /**
     * 异常处理
     **/
    private String exHandle;
    /**
     * 异常处理备注
     **/
    private String handleRemark;
    /**
     * 异常处理人
     **/
    private Long handleUser;
    /**
     * 异常处理时间
     **/
    private Date handleTime;
    /**
     * 快递单号
     **/
    private String expressNo;
    /**
     * 增加仓库ID
     **/
    private Long addWarehouseId;
    /**
     * 增加库存数量
     **/
    private BigDecimal addQuantity;
    /**
     * 增加商品id
     **/
    private Long addProductId;
    /**
     * 减少仓库id
     **/
    private Long reduceWarehouseId;
    /**
     * 减少库存数量
     **/
    private BigDecimal reduceQuantity;
    /**
     * 减少商品id
     **/
    private Long reduceProductId;
    /**
     * 报损理赔金额
     **/
    private BigDecimal amount;

    /**
     * 源京东订单id （异常处理：仓库已发 ， 补单(不扣库存) 时选择）
     */
    private Long sourceOrderId;
}
