package com.fjhx.victoriatourist.service.jd;

import com.fjhx.victoriatourist.entity.jd.vo.JdInfoVo;
import com.fjhx.victoriatourist.entity.jd.vo.TellBackOrderVO;

import java.util.Date;
import java.util.List;

public interface JdApiService {

    JdInfoVo validJdInfo();

    /**
     * 通过code获取AccessToken
     */
    void getAccessTokenByCode(String code);

    /**
     * 构造jd登录地址
     */
    String build2LoginUrl();

    /**
     * 订单回告
     */
    void tellBackOrder(TellBackOrderVO tellBackOrderVO);

    /**
     * 开始京东订单采集
     */
    void startJdOrder(JdInfoVo jdInfoVo) throws Exception;

    /**
     * 开始京东订单采集
     */
    void startJdOrder(Date startTime, Date endTime, List<Long> orderIds) throws Exception;

    /**
     * 开始京东退货单采集
     */
    void startJdBackOrder(JdInfoVo jdInfoVo) throws Exception;

    /**
     * 刷新京东状态
     */
    void refreshJdState(JdInfoVo jdInfoVo) throws Exception;

    /**
     * 初始化租户字典表
     */
    void initTenantDict();

    /**
     * 补偿商品id为空
     */
    void compensatingProductNon();

    /**
     * 查询售后退货列表
     */
    void refundInfo(JdInfoVo jdInfoVo) throws Exception;

}
