package com.fjhx.victoriatourist.service.jd.entity;

import com.jd.open.api.sdk.internal.util.JsonUtil;
import com.jd.open.api.sdk.request.AbstractRequest;
import com.jd.open.api.sdk.request.JdRequest;
import lombok.Getter;
import lombok.Setter;

import java.io.IOException;
import java.util.Map;
import java.util.TreeMap;

@Setter
@Getter
public class RefundDetailRequest extends AbstractRequest implements JdRequest<RefundDetailResponse> {
    private String loginName;
    private Long refundId;
    private String vendorCode;

    public RefundDetailRequest() {
    }

    public String getApiMethod() {
        return "jingdong.ediws.ro.refundInfoDetail.get";
    }

    public String getAppJsonParams() throws IOException {
        Map<String, Object> pmap = new TreeMap();
        pmap.put("loginName", this.loginName);
        pmap.put("refundId", this.refundId);
        pmap.put("vendorCode", this.vendorCode);
        return JsonUtil.toJson(pmap);
    }

    public Class<RefundDetailResponse> getResponseClass() {
        return RefundDetailResponse.class;
    }
}