package com.fjhx.victoriatourist.service.jd.factory;

import cn.hutool.core.util.StrUtil;
import com.fjhx.victoriatourist.entity.jd.vo.JdInfoVo;
import com.fjhx.victoriatourist.service.jd.JdInfoService;
import com.fjhx.victoriatourist.service.jd.constants.JdParamConstant;
import com.jd.open.api.sdk.DefaultJdClient;
import com.jd.open.api.sdk.JdClient;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
public class JdClientFactory {

    @Resource
    JdInfoService jdInfoService;

    @Bean
    public JdClient jdClient() {
        JdInfoVo jdInfoVo = jdInfoService.getOne();
        if (StrUtil.isBlank(jdInfoVo.getAccessToken())) {
            throw new RuntimeException("京东accessToken为空");
        }
        return new DefaultJdClient(JdParamConstant.SERVER_URL, jdInfoVo.getAccessToken(), JdParamConstant.appKey, JdParamConstant.appSecret);
    }

}