package com.fjhx.victoriatourist.service.jd.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.collection.ListUtil;
import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.fjhx.common.constant.SourceConstant;
import com.fjhx.item.entity.product.po.ProductInfo;
import com.fjhx.item.service.product.ProductInfoService;
import com.fjhx.tenant.entity.dict.dto.DictTenantDataDto;
import com.fjhx.tenant.entity.dict.dto.DictTenantTypeDto;
import com.fjhx.tenant.entity.dict.po.DictTenantData;
import com.fjhx.tenant.entity.dict.po.DictTenantType;
import com.fjhx.tenant.service.dict.DictTenantDataService;
import com.fjhx.tenant.service.dict.DictTenantTypeService;
import com.fjhx.victoriatourist.entity.jd.dto.JdInfoDto;
import com.fjhx.victoriatourist.entity.jd.po.JdBack;
import com.fjhx.victoriatourist.entity.jd.po.JdBackDetails;
import com.fjhx.victoriatourist.entity.jd.po.JdOrder;
import com.fjhx.victoriatourist.entity.jd.po.JdOrderDetails;
import com.fjhx.victoriatourist.entity.jd.po.JdRefund;
import com.fjhx.victoriatourist.entity.jd.po.JdRefundDetail;
import com.fjhx.victoriatourist.entity.jd.vo.CommonDictData;
import com.fjhx.victoriatourist.entity.jd.vo.JdInfoVo;
import com.fjhx.victoriatourist.entity.jd.vo.TellBackOrderVO;
import com.fjhx.victoriatourist.service.jd.JdApiService;
import com.fjhx.victoriatourist.service.jd.JdBackDetailsService;
import com.fjhx.victoriatourist.service.jd.JdBackService;
import com.fjhx.victoriatourist.service.jd.JdInfoService;
import com.fjhx.victoriatourist.service.jd.JdOrderDetailsService;
import com.fjhx.victoriatourist.service.jd.JdOrderService;
import com.fjhx.victoriatourist.service.jd.JdRefundDetailService;
import com.fjhx.victoriatourist.service.jd.JdRefundService;
import com.fjhx.victoriatourist.service.jd.constants.InitDictConstant;
import com.fjhx.victoriatourist.service.jd.constants.JdParamConstant;
import com.fjhx.victoriatourist.service.jd.constants.RunParamConstant;
import com.fjhx.victoriatourist.service.jd.entity.RefundDetailRequest;
import com.fjhx.victoriatourist.service.jd.entity.RefundDetailResponse;
import com.fjhx.victoriatourist.service.jd.entity.RefundDetailResult;
import com.google.common.collect.HashBasedTable;
import com.google.common.collect.Table;
import com.jd.open.api.sdk.JdClient;
import com.jd.open.api.sdk.domain.supplier.PoCommonForJosWebService.response.getcomponentlist.Component;
import com.jd.open.api.sdk.domain.supplier.PoCommonForJosWebService.response.getwaredeliverdistinctlist.WarehouseDto;
import com.jd.open.api.sdk.domain.supplier.PoQueryForJosWebService.response.getdetailbyorderid.JOSDetailResultDto;
import com.jd.open.api.sdk.domain.supplier.PoQueryForJosWebService.response.getdetailbyorderid.PurchaseAllocationDetailDto;
import com.jd.open.api.sdk.domain.supplier.PoQueryForJosWebService.response.getpurchaseorderlist.JOSOrderResultDto;
import com.jd.open.api.sdk.domain.supplier.PoQueryForJosWebService.response.getpurchaseorderlist.PurchaseOrderDto;
import com.jd.open.api.sdk.domain.supplier.ReturnOrderForJosWebService.response.detail.DetailResultDto;
import com.jd.open.api.sdk.domain.supplier.ReturnOrderForJosWebService.response.get.RoDto;
import com.jd.open.api.sdk.domain.supplier.ReturnOrderForJosWebService.response.get.RoResultDto;
import com.jd.open.api.sdk.domain.supplier.SparePartInventoryJosService.response.list.JosResult;
import com.jd.open.api.sdk.request.supplier.EdiwsRoRefundInfoListRequest;
import com.jd.open.api.sdk.request.supplier.VcConfirmpurchaseorderRequest;
import com.jd.open.api.sdk.request.supplier.VcGetReturnOrderDetailRequest;
import com.jd.open.api.sdk.request.supplier.VcGetcomponentlistRequest;
import com.jd.open.api.sdk.request.supplier.VcGetdetailbyorderidRequest;
import com.jd.open.api.sdk.request.supplier.VcGetpurchaseorderlistRequest;
import com.jd.open.api.sdk.request.supplier.VcGetwaredeliverdistinctlistRequest;
import com.jd.open.api.sdk.request.supplier.VcReturnOrderListPageGetRequest;
import com.jd.open.api.sdk.response.AbstractResponse;
import com.jd.open.api.sdk.response.supplier.EdiwsRoRefundInfoListResponse;
import com.jd.open.api.sdk.response.supplier.VcConfirmpurchaseorderResponse;
import com.jd.open.api.sdk.response.supplier.VcGetReturnOrderDetailResponse;
import com.jd.open.api.sdk.response.supplier.VcGetcomponentlistResponse;
import com.jd.open.api.sdk.response.supplier.VcGetdetailbyorderidResponse;
import com.jd.open.api.sdk.response.supplier.VcGetpurchaseorderlistResponse;
import com.jd.open.api.sdk.response.supplier.VcGetwaredeliverdistinctlistResponse;
import com.jd.open.api.sdk.response.supplier.VcReturnOrderListPageGetResponse;
import com.ruoyi.common.core.domain.BaseIdPo;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.IOUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.impl.client.HttpClients;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.function.Function;
import java.util.stream.Collectors;

@Slf4j
@Service
public class JdApiServiceImpl implements JdApiService {

    private static final Map<String, String> componentDictTypeMap = new HashMap<String, String>() {{
        put("confirmState", "回告状态");
        put("orderAttribute", "订单属性");
        put("Status", "删除状态");
        put("BackExplanationType", "图书回告不满足原因");
        put("OrderState", "订单状态");
    }};

    //订单状态：审核不通过/供应商驳回/已完成
    private static final ArrayList<String> notIn = new ArrayList<String>() {{
        add("7");
        add("20");
        add("3");
    }};

    private static final Map<String, String> returnStatesMap = new HashMap<String, String>() {{
        put("1", "初始退货单");
        put("2", "等待经理审核");
        put("3", "等待总监审核");
        put("4", "等待质控审核");
        put("5", "审核通过");
        put("9", "等待退货机构出库");
        put("10", "等待目的机构入库");
        put("11", "等待退货区收货");
        put("13", "等待供应商收货");
        put("17", "报废等待结算");
        put("18", "提货等待结算");
        put("20", "已完成");
        put("21", "等待删除确认");
        put("22", "已删除");
    }};

    @Autowired
    private JdOrderService jdOrderService;
    @Autowired
    private JdOrderDetailsService jdOrderDetailsService;
    @Autowired
    private JdBackService jdBackService;
    @Autowired
    private JdBackDetailsService jdBackDetailsService;
    @Resource
    private JdInfoService jdInfoService;
    @Resource
    private ProductInfoService productInfoService;
    @Resource
    private DictTenantTypeService dictTenantTypeService;
    @Resource
    private DictTenantDataService dictTenantDataService;
    @Resource
    private JdRefundService jdRefundService;
    @Resource
    private JdRefundDetailService jdRefundDetailService;
    @Resource
    private JdClient jdClient;

    /**
     * 请求API工具方法
     */
    private static JSONObject getJSON(HttpRequestBase httpRequestBase) throws IOException {
        HttpClient client = HttpClients.createDefault();
        httpRequestBase.setConfig(RequestConfig.custom().setConnectTimeout(3000).build());
        HttpResponse response = client.execute(httpRequestBase);
        int statusCode = response.getStatusLine().getStatusCode();
        HttpEntity entity = response.getEntity();
        String responseStr = IOUtils.toString(entity.getContent(), StandardCharsets.UTF_8);
        if (statusCode != 200) {
            log.error("请求失败 {} {} {}", statusCode, httpRequestBase.getURI(), responseStr);
        }
        return JSONObject.parseObject(responseStr);
    }

    //每小时执行一次
    @Scheduled(cron = "0 0 0/1 * * ?")
    public void refreshToken() {
        JdInfoVo jdInfoVo = jdInfoService.getOne();
        //如果过期时间减去当前时间小于90分钟，则要刷新token
        if (ObjectUtil.isNotNull(jdInfoVo.getExpireTime())) {
            long between = DateUtil.between(DateUtil.date(), jdInfoVo.getExpireTime(), DateUnit.MINUTE, false);
            if (between <= 0) {
                if (jdInfoVo.getOnline() > 0) {
                    jdInfoVo.setOnline(0);
                    jdInfoService.updateById(jdInfoVo);
                }
            } else if (90 >= between) {
                refreshToken(jdInfoVo);
            }
        }
    }

    @Override
    public JdInfoVo validJdInfo() {
        JdInfoVo jdInfoVo = jdInfoService.getOne();
        boolean online = jdInfoVo.getOnline() > 0;
        if (!online) {
            log.info("京东已经下线");
            return null;
        }
        //开始校验是否符合条件
        if (ObjectUtil.isNull(jdInfoVo.getInitQueryDate())) {
            log.error("请线配置京东初始化查询时间");
            return null;
        }
        return jdInfoVo;
    }

    /**
     * 通过code获取AccessToken
     */
    @Override
    public void getAccessTokenByCode(String code) {
        //获取AccessToken并存入数据库
        String path = RunParamConstant.JD_GET_ACCESS_TOKEN_URL;
        path = String.format(path, JdParamConstant.appKey, JdParamConstant.appSecret, code);
        try {
            JSONObject responseJson = getJSON(new HttpGet(path));
            System.out.println(responseJson);
            dealJdTokenResponse(responseJson);
        } catch (Exception e) {
            log.error("获取AccessToken出错：" + e.getMessage(), e);
        }
    }

    @Override
    public String build2LoginUrl() {
        String url = RunParamConstant.JD_LOGIN_URL;
        //redirect_uri需要加上项目的域名
        url = String.format(url, JdParamConstant.appKey, RunParamConstant.redirect_uri, DateUtil.format(new Date(), "yyyyMMddHHmmss"));
        return url;
    }

    @Override
    public void tellBackOrder(TellBackOrderVO tellBackOrderVO) {
        VcConfirmpurchaseorderResponse response;
        try {
            VcConfirmpurchaseorderRequest request = buildConfirmpurchaseorderRequest(tellBackOrderVO);
            response = jdClient.execute(request);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        String code = response.getCode();
        if (!"0".equals(code)) {
            //失败
            log.error("回告失败：{}，{}", response.getZhDesc(), response.getMsg());
            throw new RuntimeException("回告失败");
        } else {
            Boolean successFlag = false;
            String msg = "回告失败";
            try {
                successFlag = JSONObject.parse(response.getMsg()).getJSONObject("jingdong_vc_confirmpurchaseorder_responce").getJSONObject("base_result").getBoolean("success");
                msg = msg + "：" + JSONObject.parse(response.getMsg()).getJSONObject("jingdong_vc_confirmpurchaseorder_responce").getJSONObject("base_result").getString("result_message");
            } catch (Exception e) {
                log.error("回告返回解析异常：{}", response.getMsg());
            }
            if (!successFlag) {
                //失败
                log.error("回告失败：{}，{}", response.getZhDesc(), response.getMsg());
                throw new RuntimeException(msg);
            }
        }
    }

    private VcConfirmpurchaseorderRequest buildConfirmpurchaseorderRequest(TellBackOrderVO tellBackOrderVO) {
        VcConfirmpurchaseorderRequest request = new VcConfirmpurchaseorderRequest();
        request.setOrderId(tellBackOrderVO.getOrderId());
        request.setDeliveryTime(tellBackOrderVO.getDeliveryTime());
        request.setWareId(tellBackOrderVO.getBackInfo().stream().map(o -> StrUtil.toString(o.getWareId())).collect(Collectors.joining(",")));
        request.setConfirmNum(tellBackOrderVO.getBackInfo().stream().map(o -> StrUtil.toString(o.getConfirmNum())).collect(Collectors.joining(",")));
        request.setBackExplanation(tellBackOrderVO.getBackInfo().stream().map(o -> StrUtil.toString(o.getNonDeliveryReason())).collect(Collectors.joining(",")));
//        request.setBackExplanationType(tellBackOrderVO.getBackInfo().stream().map(o->StrUtil.toString(o.getBackExplanationType())).collect(Collectors.joining(",")));
        request.setDeliverCenterId(tellBackOrderVO.getBackInfo().stream().map(o -> StrUtil.toString(o.getDeliverCenterId())).collect(Collectors.joining(",")));
        return request;
    }

    /**
     * 刷新Token
     */
    private void refreshToken(JdInfoVo jdInfoVo) {
        if (ObjectUtil.isEmpty(jdInfoVo.getAccessToken())) {
            log.error("accessToken为空无法刷新Token请检查");
            return;
        }
        if (ObjectUtil.isEmpty(jdInfoVo.getRefreshToken())) {
            log.error("refreshToken为空无法刷新Token请检查");
            return;
        }
        String path = RunParamConstant.JD_REFRESH_URL;
        path = String.format(path, JdParamConstant.appKey, JdParamConstant.appSecret, jdInfoVo.getRefreshToken());
        try {
            JSONObject responseJson = getJSON(new HttpGet(path));
            dealJdTokenResponse(responseJson);
        } catch (Exception e) {
            log.error("刷新AccessToken出错：" + e.getMessage(), e);
        }
    }

    /**
     * 开始京东订单采集
     *
     * @author hj
     * @date 2023/12/13 22:30
     */
    @DSTransactional
    @Override
    public void startJdOrder(JdInfoVo jdInfoVo) throws Exception {
        if (ObjectUtil.isNull(jdInfoVo)) {
            return;
        }
        //获取开始同步的时间
        Date startTime = jdInfoVo.getInitQueryDate();
        Date endTime = new Date();

        //根据下单时间获取数据库里最后一个订单
        JdOrder lastJdOrder = jdOrderService.getOne(q -> q.orderByDesc(JdOrder::getCreatedDate));
        if (ObjectUtil.isNotNull(lastJdOrder)) {
            startTime = lastJdOrder.getCreatedDate();
        }

        startJdOrder(startTime, endTime, null);

    }

    @DSTransactional
    @Override
    public void startJdOrder(Date startTime, Date endTime, List<Long> orderIds) throws Exception {
        List<PurchaseOrderDto> purchaseOrderDtoList = getJdOrderInfo(startTime, endTime, orderIds);

        if (CollectionUtil.isEmpty(purchaseOrderDtoList)) {
            return;
        }

        // 订单id集合
        Set<Long> orderIdSet = purchaseOrderDtoList.stream().map(PurchaseOrderDto::getOrderId).collect(Collectors.toSet());

        // 获取已同步的京东订单id
        Set<Long> existOrderIdSet = jdOrderService.list(q -> q.select(JdOrder::getOrderId).in(JdOrder::getOrderId, orderIdSet))
                .stream().map(JdOrder::getOrderId).collect(Collectors.toSet());

        // 过滤已同步的订单
        purchaseOrderDtoList = purchaseOrderDtoList.stream()
                .filter(item -> !existOrderIdSet.contains(item.getOrderId()))
                .collect(Collectors.toList());

        // 转为系统自己的实体类
        List<JdOrder> jdOrderList = BeanUtil.copyToList(purchaseOrderDtoList, JdOrder.class);

        // 获取明细
        List<JdOrderDetails> jdOrderDetailsList = new ArrayList<>();

        for (JdOrder jdOrder : jdOrderList) {
            jdOrder.setId(IdWorker.getId());
            jdOrder.setTenantId(RunParamConstant.tenantId);
            boolean hasExFlag = dealOrderDetail(jdOrder, jdOrderDetailsList);
            if (hasExFlag) {
                jdOrder.setHasEx(RunParamConstant.EXCEPTION);
                jdOrder.setHandleStatus(RunParamConstant.EXCEPTION_STATE_UNTREATED);
            }
        }

        // 将数据存储到库
        jdOrderService.saveBatch(jdOrderList);
        jdOrderDetailsService.saveOrUpdateBatch(jdOrderDetailsList);
    }

    /**
     * 开始京东退货单采集
     */
    @DSTransactional
    @Override
    public void startJdBackOrder(JdInfoVo jdInfoVo) throws Exception {
        if (ObjectUtil.isNull(jdInfoVo)) {
            return;
        }
        Date startTime = jdInfoVo.getInitQueryDate();
        Date endTime = new Date();
        //根据下单时间获取数据库里最后一个订单
        JdBack lastJdBack = jdBackService.getOne(q -> q.orderByDesc(JdBack::getCreateDate));
        if (ObjectUtil.isNotNull(lastJdBack)) {
            //将最后一个下单时间设置为开始时间
            startTime = lastJdBack.getCreateDate();
        }

        List<RoDto> roDtoList = getJdBackInfo(startTime, endTime);
        if (CollectionUtil.isEmpty(roDtoList)) {
            return;
        }

        //过滤出不在数据库里的新数据
        List<Long> returnIds = roDtoList.stream().map(RoDto::getReturnId).collect(Collectors.toList());
        List<Long> existReturnIds = jdBackService.list(q -> q.select(JdBack::getReturnId).in(JdBack::getReturnId, returnIds))
                .stream().map(JdBack::getReturnId).collect(Collectors.toList());
        roDtoList = roDtoList.stream().filter(item -> !existReturnIds.contains(item.getReturnId())).collect(Collectors.toList());

        //转成我们自己的实体类
        List<JdBack> jdBackList = BeanUtil.copyToList(roDtoList, JdBack.class);

        //获取明细
        List<JdBackDetails> JdBackDetailsList = new ArrayList<>();

        Set<Long> wareIdSet = new HashSet<>();

        for (JdBack jdBack : jdBackList) {
            jdBack.setId(IdWorker.getId());

            VcGetReturnOrderDetailRequest request = new VcGetReturnOrderDetailRequest();
            request.setReturnId(jdBack.getReturnId());
            VcGetReturnOrderDetailResponse response = jdClient.execute(request);
            DetailResultDto detailResultDto = response.getDetailResultDto();
            List<JdBackDetails> jdBackDetails = BeanUtil.copyToList(detailResultDto.getDetailDtoList(), JdBackDetails.class);

            jdBackDetails.forEach(item -> {
                item.setJdBackId(jdBack.getId());
                wareIdSet.add(item.getWareId());
            });
            JdBackDetailsList.addAll(jdBackDetails);
        }

        // 赋值产品编码
        try {
            DynamicDataSourceContextHolder.push(SourceConstant.ITEM);
            Map<String, Long> map = productInfoService.mapKV(ProductInfo::getCustomCode, BaseIdPo::getId,
                    q -> q.in(ProductInfo::getCustomCode, wareIdSet));
            JdBackDetailsList.forEach(item -> item.setProductId(map.get(item.getWareId().toString())));
        } finally {
            DynamicDataSourceContextHolder.poll();
        }

        jdBackService.saveBatch(jdBackList);
        jdBackDetailsService.saveBatch(JdBackDetailsList);
    }

    /**
     * 刷新京东状态
     */
    @DSTransactional
    @Override
    public void refreshJdState(JdInfoVo jdInfoVo) throws Exception {
        if (ObjectUtil.isNull(jdInfoVo)) {
            return;
        }
        Date endDate = new Date();
        Date startDate = DateUtil.offsetMonth(endDate, -3);

        //1.查询列表订单状态不为审核不通过/供应商驳回/已完成
        List<JdOrder> jdOrders = jdOrderService.list(q -> q
                .notIn(JdOrder::getState, notIn)
                .between(JdOrder::getCreatedDate, startDate, endDate)
                .orderByDesc(JdOrder::getCreatedDate)
        );

        if (CollectionUtil.isEmpty(jdOrders)) {
            return;
        }

        Map<Long, JdOrder> jdOrderMap = jdOrders.stream().collect(Collectors.toMap(JdOrder::getOrderId, Function.identity()));

        // 2.按50个订单查询京东订单状态
        List<List<JdOrder>> splitJdOrder = ListUtil.split(jdOrders, 50);

        for (List<JdOrder> orders : splitJdOrder) {
            List<Long> orderIdList = orders.stream().map(JdOrder::getOrderId).collect(Collectors.toList());
            List<PurchaseOrderDto> jdOrderInfo = getJdOrderInfo(null, null, orderIdList);
            List<JdOrder> jdOrderList = BeanUtil.copyToList(jdOrderInfo, JdOrder.class);

            //3.更新订单信息
            for (JdOrder jdOrder : jdOrderList) {
                Long id = jdOrderMap.get(jdOrder.getOrderId()).getId();
                jdOrder.setId(id);
                if (JdParamConstant.JD_ORDER_STATE_FINISH.equals(jdOrder.getState())) {
                    List<JdOrderDetails> jdOrderDetailsList = new ArrayList<>();

                    //重新插入明细
                    boolean hasExFlag = dealOrderDetail(jdOrder, jdOrderDetailsList);

                    //获取当前明细记录
                    List<JdOrderDetails> dbJdOrderDetails = jdOrderDetailsService.list(q -> q.eq(JdOrderDetails::getJdOrderId, id));
                    Table<Long, Long, JdOrderDetails> jdOrderDetailsTable = HashBasedTable.create();
                    jdOrderDetailsList.forEach(item -> jdOrderDetailsTable.put(item.getOrderId(), item.getWareId(), item));

                    for (JdOrderDetails dbJdOrderDetail : dbJdOrderDetails) {
                        JdOrderDetails onlineJdOrderDetails = jdOrderDetailsTable.get(dbJdOrderDetail.getOrderId(), dbJdOrderDetail.getWareId());
                        dbJdOrderDetail.setDeliverCenterId(onlineJdOrderDetails.getDeliverCenterId());
                        dbJdOrderDetail.setDeliverCenterName(onlineJdOrderDetails.getDeliverCenterName());
                        dbJdOrderDetail.setWareName(onlineJdOrderDetails.getWareName());
                        dbJdOrderDetail.setPurchasePrice(onlineJdOrderDetails.getPurchasePrice());
                        dbJdOrderDetail.setOriginalNum(onlineJdOrderDetails.getOriginalNum());
                        dbJdOrderDetail.setConfirmNum(onlineJdOrderDetails.getConfirmNum());
                        dbJdOrderDetail.setActualNum(onlineJdOrderDetails.getActualNum());
                        dbJdOrderDetail.setNonDeliveryReason(onlineJdOrderDetails.getNonDeliveryReason());
                        dbJdOrderDetail.setTotoalPrice(onlineJdOrderDetails.getTotoalPrice());
                        dbJdOrderDetail.setStoreId(onlineJdOrderDetails.getStoreId());
                        dbJdOrderDetail.setStoreName(onlineJdOrderDetails.getStoreName());
                        dbJdOrderDetail.setHasEx(onlineJdOrderDetails.getHasEx());
                        dbJdOrderDetail.setExDesc(onlineJdOrderDetails.getExDesc());
                        dbJdOrderDetail.setHandleStatus(onlineJdOrderDetails.getHandleStatus());
                    }

                    if (hasExFlag) {
                        jdOrder.setHasEx(RunParamConstant.EXCEPTION);
                        jdOrder.setHandleStatus(RunParamConstant.EXCEPTION_STATE_UNTREATED);
                    } else {
                        jdOrder.setHasEx(RunParamConstant.NO_EXCEPTION);
                        jdOrder.setHandleStatus(null);
                    }

                    jdOrderDetailsService.updateBatchById(dbJdOrderDetails);
                }
                jdOrderService.updateById(jdOrder);
            }
        }
    }

    /**
     * 初始化租户字典表
     */
    @DSTransactional
    @Override
    public void initTenantDict() {
        try {
            DynamicDataSourceContextHolder.push(SourceConstant.BASE);
            handleDeliveryCenter();
            handleComponent();
            handleReturnStates();
        } finally {
            DynamicDataSourceContextHolder.poll();
        }
    }

    /**
     * 补偿商品id为空
     */
    @DSTransactional
    @Override
    public void compensatingProductNon() {

        List<JdOrderDetails> list = jdOrderDetailsService.list(q -> q
                .select(BaseIdPo::getId, JdOrderDetails::getWareId)
                .isNull(JdOrderDetails::getProductId)
        );

        if (list.isEmpty()) {
            return;
        }

        Map<String, Long> productMap;

        try {
            DynamicDataSourceContextHolder.push(SourceConstant.ITEM);
            Set<String> wareIdSet = list.stream().map(item -> item.getWareId().toString()).collect(Collectors.toSet());
            productMap = productInfoService.mapKV(ProductInfo::getCustomCode, ProductInfo::getId,
                    q -> q.in(ProductInfo::getCustomCode, wareIdSet));
        } finally {
            DynamicDataSourceContextHolder.poll();
        }

        List<JdOrderDetails> updateList = list.stream().filter(item -> {
            Long productId = productMap.get(item.getWareId().toString());
            if (productId == null) {
                return false;
            }

            item.setProductId(productId);
            return true;
        }).collect(Collectors.toList());

        if (updateList.isEmpty()) {
            return;
        }

        jdOrderDetailsService.updateBatchById(updateList);
    }

    @DSTransactional
    @Override
    public void refundInfo(JdInfoVo jdInfoVo) throws Exception {
        if (ObjectUtil.isNull(jdInfoVo)) {
            return;
        }

        //获取开始同步的时间
        Date startTime = DateUtil.parseDateTime("2024-09-23 00:00:00");
        Date endTime = new Date();

        //根据下单时间获取数据库里最后一个订单
        JdRefund lastJdRefund = jdRefundService.getOne(q -> q.orderByDesc(JdRefund::getApplyDateTime));
        if (ObjectUtil.isNotNull(lastJdRefund)) {
            startTime = DateUtil.offsetSecond(lastJdRefund.getApplyDateTime(), 1);
        }

        List<JdRefund> jdRefunds = getRefundInfoList(startTime, endTime);
        jdRefundService.saveBatch(jdRefunds);

        List<JdRefundDetail> jdRefundDetails = getJdRefundDetails(jdRefunds);
        jdRefundDetailService.saveBatch(jdRefundDetails);

    }

    private List<JdRefundDetail> getJdRefundDetails(List<JdRefund> jdRefunds) throws Exception {

        List<JdRefundDetail> jdRefundDetails = new ArrayList<>();
        for (JdRefund jdRefund : jdRefunds) {
            RefundDetailRequest request = new RefundDetailRequest();
            request.setRefundId(jdRefund.getRefundId());
            request.setVendorCode(RunParamConstant.VENDOR_CODE);

            RefundDetailResponse response = jdClient.execute(request);
            validSuccess(response, "获取京东售后退货详情");

            RefundDetailResult result = response.getResult();

            if (!result.getSuccess()) {
                throw new RuntimeException("获取京东售后退货详情失败：" + result.getMessage());
            }

            List<JdRefundDetail> data = result.getData();
            data.forEach(item -> {
                item.setJdRefundId(jdRefund.getId());
                item.setStatus(0);
            });
            jdRefundDetails.addAll(data);
        }

        return jdRefundDetails;
    }

    /**
     * 获取京东订单信息分页
     */
    private JSONObject getRefundInfoList(Integer pageIndex, Integer pageSize, Date startTime, Date endTime) throws Exception {
        EdiwsRoRefundInfoListRequest request = new EdiwsRoRefundInfoListRequest();
        request.setApplyBeginTime(startTime);
        request.setApplyEndTime(endTime);
        request.setPageIndex(pageIndex);
        request.setPageSize(pageSize);
        request.setVendorCode(RunParamConstant.VENDOR_CODE);
        EdiwsRoRefundInfoListResponse response = jdClient.execute(request);
        validSuccess(response, "获取京东售后退货列表");
        JosResult result = response.getResult();
        boolean success = result.getSuccess();
        if (!success) {
            throw new RuntimeException("获取京东售后退货列表失败：" + result.getMessage());
        }

        return JSONObject.parseObject(response.getMsg())
                .getJSONObject("jingdong_ediws_ro_refundInfo_list_responce")
                .getJSONObject("result");
    }

    private List<JdRefund> getRefundInfoList(Date startTime, Date endTime) throws Exception {
        int pageIndex = 1;
        int pageSize = 50;
        long recordCount;

        List<JdRefund> list = new ArrayList<>();
        do {
            JSONObject result = getRefundInfoList(pageIndex, pageSize, startTime, endTime);
            pageIndex++;
            list.addAll(result.getJSONArray("data").toList(JdRefund.class));
            recordCount = result.getIntValue("recordCount");
        } while (recordCount > (long) (pageIndex - 1) * pageSize);
        Collections.reverse(list);

        return list;
    }

    private boolean dealOrderDetail(JdOrder jdOrder, List<JdOrderDetails> jdOrderDetailsList) throws Exception {

        DynamicDataSourceContextHolder.push(SourceConstant.ITEM);
        AtomicBoolean hasExFlag = new AtomicBoolean(false);

        try {
            VcGetdetailbyorderidRequest request = new VcGetdetailbyorderidRequest();
            request.setOrderId(jdOrder.getOrderId());
            request.setIsPage(false);
            VcGetdetailbyorderidResponse response = jdClient.execute(request);
            JOSDetailResultDto josDetailResultDto = response.getJosDetailResultDto();
            List<PurchaseAllocationDetailDto> purchaseAllocationDetailList = josDetailResultDto.getPurchaseAllocationDetailList();
            List<JdOrderDetails> jdOrderDetails = BeanUtil.copyToList(purchaseAllocationDetailList, JdOrderDetails.class);

            Set<String> wareIdSet = jdOrderDetails.stream().map(item -> item.getWareId().toString()).collect(Collectors.toSet());
            Map<String, Long> productMap = productInfoService.mapKV(ProductInfo::getCustomCode, ProductInfo::getId,
                    q -> q.in(ProductInfo::getCustomCode, wareIdSet));

            jdOrderDetails.forEach(item -> {
                item.setJdOrderId(jdOrder.getId());
                item.setProductId(productMap.get(item.getWareId().toString()));

                if (JdParamConstant.JD_ORDER_STATE_FINISH.equals(jdOrder.getState())) {
                    //如果京东采购单状态 = 已完成  &  明细数据中存在 实收 != 回告 & 分流类型 == 仓库发货(10)，则给京东采购单打上【异常】标记
                    //如果实收>回告，则：给对应的明细打上【多货】标记;如果实收<回告，则：给对应的明细打上【少货】标记
                    if (
                            ObjectUtil.isNotNull(item.getActualNum())
                                    && ObjectUtil.isNotNull(item.getConfirmNum())
                                    && ObjectUtil.isNotEmpty(jdOrder.getDiversionType())
                                    && item.getActualNum().compareTo(item.getConfirmNum()) != 0
                                    && jdOrder.getDiversionType() == 10
                    ) {
                        String exDesc;
                        if (item.getActualNum().compareTo(item.getConfirmNum()) > 0) {
                            exDesc = RunParamConstant.EXCESS;
                        } else {
                            exDesc = RunParamConstant.SHORTAGE;
                        }
                        item.setHasEx(RunParamConstant.EXCEPTION);
                        item.setExDesc(exDesc);
                        item.setHandleStatus(RunParamConstant.EXCEPTION_STATE_UNTREATED);
                        hasExFlag.set(true);
                    } else {
                        item.setHasEx(null);
                        item.setExDesc(null);
                        item.setHandleStatus(null);
                    }
                }
            });
            jdOrderDetailsList.addAll(jdOrderDetails);
        } finally {
            DynamicDataSourceContextHolder.poll();
        }
        return hasExFlag.get();
    }

    /**
     * 处理回告状态、订单属性、删除状态、图书回告不满足原因、订单状态
     */
    private void handleComponent() {
        componentDictTypeMap.forEach((k, v) -> {
            VcGetcomponentlistRequest request = new VcGetcomponentlistRequest();
            try {
                request.setType(k);
                VcGetcomponentlistResponse response = jdClient.execute(request);

                DictTenantType dictTenantType = handleDictType(k, v);

                List<CommonDictData> commonDictDataList = new ArrayList<>();
                List<Component> arg89 = response.getArg89();
                for (Component component : arg89) {
                    commonDictDataList.add(new CommonDictData(component.getKey(), component.getName()));
                }
                handleDictData(commonDictDataList, dictTenantType);

            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        });
    }

    /**
     * 处理配送中心字典转换
     */
    private void handleDeliveryCenter() {
        //获取京东仓库,并存入字典表
        VcGetwaredeliverdistinctlistRequest request = new VcGetwaredeliverdistinctlistRequest();

        try {
            VcGetwaredeliverdistinctlistResponse response = jdClient.execute(request);

            DictTenantType dictTenantType = handleDictType(InitDictConstant.DELIVERY_CENTER, InitDictConstant.DELIVERY_CENTER_LABEL);
            //处理字典数据表
            List<WarehouseDto> warehouseList = response.getJosWarehouseResultDto().getWarehouseList();
            List<CommonDictData> commonDictDataList = new ArrayList<>();
            for (WarehouseDto warehouseDto : warehouseList) {
                commonDictDataList.add(new CommonDictData(StrUtil.toString(warehouseDto.getDeliverCenterId()), warehouseDto.getDeliverCenterName()));
            }
            handleDictData(commonDictDataList, dictTenantType);
        } catch (Exception e) {
            log.error("转换配送中心到字典出现异常", e);
        }
    }

    /**
     * 处理jd退货状态字典
     */
    private void handleReturnStates() {
        try {
            DictTenantType dictTenantType = handleDictType(InitDictConstant.RETURN_STATES, InitDictConstant.RETURN_STATES_LABEL);
            List<CommonDictData> commonDictDataList = new ArrayList<>();
            returnStatesMap.forEach((k, v) -> commonDictDataList.add(new CommonDictData(k, v)));
            handleDictData(commonDictDataList, dictTenantType);
        } catch (Exception e) {
            log.error("处理jd退货状态字典出现异常", e);
        }
    }

    /**
     * 处理字典表
     */
    private void handleDictData(List<CommonDictData> commonDictDataList, DictTenantType dictTenantType) {
        //查出原来的字典
        List<DictTenantData> list = dictTenantDataService.lambdaQuery().eq(DictTenantData::getDictCode, dictTenantType.getCode()).orderByAsc(DictTenantData::getSort).list();
        Map<String, DictTenantData> dictDataMap = new HashMap<>();
        int sort = 10;
        if (CollectionUtil.isNotEmpty(list)) {
            dictDataMap = list.stream().collect(Collectors.toMap(DictTenantData::getDictKey, o -> o, (v1, v2) -> v2));
            sort = list.get(list.size() - 1).getSort() + 10;
        }
        List<DictTenantData> dataList = new ArrayList<>();
        for (CommonDictData commonDictData : commonDictDataList) {
            DictTenantDataDto dictTenantDataDto = new DictTenantDataDto();
            DictTenantData dictTenantData = dictDataMap.get(commonDictData.getKey());
            if (ObjectUtil.isNotNull(dictTenantData)) {
                BeanUtil.copyProperties(dictTenantData, dictTenantDataDto);
            } else {
                dictTenantDataDto.setDictCode(dictTenantType.getCode());
                dictTenantDataDto.setDictKey(StrUtil.toString(commonDictData.getKey()));
                dictTenantDataDto.setTenantId(RunParamConstant.tenantId);
                dictTenantDataDto.setSort(sort);
                sort = sort + 10;
            }
            dictTenantDataDto.setDictValue(commonDictData.getValue());
            dataList.add(dictTenantDataDto);
        }
        dictTenantDataService.saveOrUpdateBatch(dataList);
    }

    /**
     * 处理字典类型表
     */
    private DictTenantType handleDictType(String code, String name) {
        DictTenantType dictTenantType = new DictTenantType();
        List<DictTenantType> deliveryCenters = dictTenantTypeService.list(q -> q.eq(DictTenantType::getTenantId, RunParamConstant.tenantId).eq(DictTenantType::getCode, code));
        //处理字典类型表
        if (CollectionUtil.isNotEmpty(deliveryCenters)) {
            dictTenantType = deliveryCenters.get(0);
        } else {
            dictTenantType.setCode(code);
            dictTenantType.setName(name);
            dictTenantType.setTenantId(RunParamConstant.tenantId);
            dictTenantType.setStatus(InitDictConstant.ENABLE);
            DictTenantTypeDto dictTenantTypeDto = BeanUtil.copyProperties(dictTenantType, DictTenantTypeDto.class);
            dictTenantTypeService.add(dictTenantTypeDto);
            dictTenantType.setId(dictTenantTypeDto.getId());
        }
        return dictTenantType;
    }

    /**
     * 将jd返回的json对象转换成jdInfoVo
     */
    private void convertJdInfoVO(JSONObject responseJson, JdInfoVo jdInfoVo) {
        jdInfoVo.setAccessToken(responseJson.getString(RunParamConstant.ACCESS_TOKEN));
        jdInfoVo.setRefreshToken(responseJson.getString(RunParamConstant.REFRESH_TOKEN));
        int expires_in = responseJson.getIntValue("expires_in", 0);
        int offsetHour = 24;
        if (expires_in > 0) {
            offsetHour = expires_in / 60 / 60;
        }
        jdInfoVo.setExpireTime(DateUtil.offsetHour(new Date(), offsetHour));
        jdInfoVo.setLastRefreshTime(DateUtil.date());
        jdInfoVo.setOnline(1);
    }

    /**
     * 处理jd返回对象
     */
    private void dealJdTokenResponse(JSONObject responseJson) {
        if (ObjectUtil.isNotEmpty(responseJson.getString(RunParamConstant.ACCESS_TOKEN)) && ObjectUtil.isNotEmpty(responseJson.getString(RunParamConstant.REFRESH_TOKEN))) {
            log.info("成功获取AccessToken并保存" + responseJson);
            JdInfoVo jdInfoVo = jdInfoService.getOne();
            convertJdInfoVO(responseJson, jdInfoVo);
            JdInfoDto jdInfoDto = BeanUtil.copyProperties(jdInfoVo, JdInfoDto.class);
            jdInfoService.addOrUpdate(jdInfoDto);
        } else {
            log.error("获取AccessToken失败：" + responseJson);
        }
    }

    /**
     * 获取京东订单信息分页
     */
    private JOSOrderResultDto getJdOrderInfo(Integer pageIndex, Integer pageSize, Date startTime, Date endTime, List<Long> orderIds) throws Exception {
        VcGetpurchaseorderlistRequest request = new VcGetpurchaseorderlistRequest();
        request.setCreatedDateStart(startTime);
        request.setCreatedDateEnd(endTime);
        request.setPageIndex(pageIndex);
        request.setPageSize(pageSize);
        if (CollectionUtil.isNotEmpty(orderIds)) {
            String orderIdsStr = orderIds.stream().map(Object::toString).collect(Collectors.joining(","));
            request.setOrderIds(orderIdsStr);
        }
        VcGetpurchaseorderlistResponse response = jdClient.execute(request);
        validSuccess(response, "获取京东订单信息分页");
        JOSOrderResultDto josOrderResultDto = response.getJosOrderResultDto();

        boolean success = josOrderResultDto.getSuccess();
        if (!success) {
            log.error("获取京东订单信息失败：{}", josOrderResultDto.getResultMessage());
            throw new RuntimeException("获取京东订单信息失败：" + josOrderResultDto.getResultMessage());
        }

        return josOrderResultDto;
    }

    /**
     * 获取京东订单信息分页
     */
    private List<PurchaseOrderDto> getJdOrderInfo(Date startTime, Date endTime, List<Long> orderIds) throws Exception {
        int pageIndex = 1;
        int pageSize = 50;
        int recordCount;

        List<PurchaseOrderDto> purchaseOrderDtoList = new ArrayList<>();
        do {
            JOSOrderResultDto jdOrderInfo = getJdOrderInfo(pageIndex, pageSize, startTime, endTime, orderIds);
            pageIndex++;
            purchaseOrderDtoList.addAll(jdOrderInfo.getPurchaseOrderList());
            recordCount = jdOrderInfo.getRecordCount();
        } while (recordCount > (pageIndex - 1) * pageSize);
        Collections.reverse(purchaseOrderDtoList);

        return purchaseOrderDtoList;
    }

    /**
     * 获取京东退货单信息分页
     */
    private RoResultDto getJdBackInfo(Integer pageIndex, Integer pageSize, Date startTime, Date endTime) throws Exception {
        VcReturnOrderListPageGetRequest request = new VcReturnOrderListPageGetRequest();
        request.setCreateDateBegin(startTime);
        request.setCreateDateEnd(endTime);
        request.setPageSize(pageSize);
        request.setPageIndex(pageIndex);
        VcReturnOrderListPageGetResponse response = jdClient.execute(request);
        validSuccess(response, "获取京东退货单信息分页");
        return response.getRoResultDto();
    }

    /**
     * 获取京东订单信息分页
     */
    private List<RoDto> getJdBackInfo(Date startTime, Date endTime) throws Exception {
        int pageIndex = 1;
        int pageSize = 50;
        int recordCount;

        List<RoDto> roDtoList = new ArrayList<>();
        do {
            RoResultDto roResultDto = getJdBackInfo(pageIndex, pageSize, startTime, endTime);
            roDtoList.addAll(roResultDto.getRoDtoList());
            recordCount = roResultDto.getRecordCount();
            pageIndex++;
        } while (recordCount > (pageIndex - 1) * pageSize);
        Collections.reverse(roDtoList);

        return roDtoList;
    }

    private void validSuccess(AbstractResponse response, String method) {
        String code = response.getCode();
        if (!"0".equals(code)) {
            log.error("获取{}失败：{}", method, response.getZhDesc());
            throw new RuntimeException("获取" + method + "失败：" + response.getZhDesc());
        }
    }

}
