package com.fjhx.wms.service.stock;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.item.entity.product.IssueImportExcelBo;
import com.fjhx.item.entity.product.dto.ProductInfoSelectDto;
import com.fjhx.item.entity.product.vo.ProductInfoVo;
import com.fjhx.wms.entity.stock.dto.StockCheckDto;
import com.fjhx.wms.entity.stock.dto.StockCheckSelectDto;
import com.fjhx.wms.entity.stock.dto.StockSelectDto;
import com.fjhx.wms.entity.stock.po.StockCheck;
import com.fjhx.wms.entity.stock.vo.StockCheckVo;
import com.fjhx.wms.entity.stock.vo.StockVo;
import com.ruoyi.common.core.service.BaseService;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;


/**
 * <p>
 * 库存盘点 服务类
 * </p>
 *
 * @author
 * @since 2023-03-22
 */
public interface StockCheckService extends BaseService<StockCheck> {

    /**
     * 库存盘点分页
     */
    Page<StockCheckVo> getPage(StockCheckSelectDto dto);

    /**
     * 库存盘点明细
     */
    StockCheckVo detail(Long id);

    /**
     * 库存盘点新增
     */
    void add(StockCheckDto stockCheckDto);

    /**
     * 获取产品列表带库存
     */
    Page<ProductInfoVo> productPage(ProductInfoSelectDto dto);

    List<IssueImportExcelBo> excelImport(MultipartFile file, Long warehouseId);

    Page<StockVo> stockProductPage(StockSelectDto dto);

    /**
     * 批量盘点提交
     */
    void submitAll();
}
